JUCE: DialogWindow Class Reference

JUCE

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
DialogWindow Class Reference
juce_gui_basics » windows

A dialog-box style window. More...

`#include <juce_DialogWindow.h>`

Inheritance diagram for DialogWindow:

## Classes
struct | LaunchOptions
| This class defines a collection of settings to be used to open a DialogWindow. More...

## Public Member Functions
| DialogWindow (const String &name, Colour backgroundColour, bool escapeKeyTriggersCloseButton, bool addToDesktop=true, float desktopScale=1.0f)
| Creates a DialogWindow. More...
| ~DialogWindow () override
| Destructor. More...
virtual bool | escapeKeyPressed ()
| Called when the escape key is pressed. More...
Public Member Functions inherited from DocumentWindow
| DocumentWindow (const String &name, Colour backgroundColour, int requiredButtons, bool addToDesktop=true)
| Creates a DocumentWindow. More...
| ~DocumentWindow () override
| Destructor. More...
void | setName (const String &newName) override
| Changes the component's name. More...
void | setIcon (const Image &imageToUse)
| Sets an icon to show in the title bar, next to the title. More...
void | setTitleBarHeight (int newHeight)
| Changes the height of the title-bar. More...
int | getTitleBarHeight () const
| Returns the current title bar height. More...
void | setTitleBarButtonsRequired (int requiredButtons, bool positionTitleBarButtonsOnLeft)
| Changes the set of title-bar buttons being shown. More...
void | setTitleBarTextCentred (bool textShouldBeCentred)
| Sets whether the title should be centred within the window. More...
void | setMenuBar (MenuBarModel *menuBarModel, int menuBarHeight=0)
| Creates a menu inside this window. More...
Component * | getMenuBarComponent () const noexcept
| Returns the current menu bar component, or null if there isn't one. More...
void | setMenuBarComponent (Component *newMenuBarComponent)
| Replaces the current menu bar with a custom component. More...
virtual void | closeButtonPressed ()
| This method is called when the user tries to close the window. More...
virtual void | minimiseButtonPressed ()
| Callback that is triggered when the minimise button is pressed. More...
virtual void | maximiseButtonPressed ()
| Callback that is triggered when the maximise button is pressed, or when the title-bar is double-clicked. More...
Button * | getCloseButton () const noexcept
| Returns the close button, (or nullptr if there isn't one). More...
Button * | getMinimiseButton () const noexcept
| Returns the minimise button, (or nullptr if there isn't one). More...
Button * | getMaximiseButton () const noexcept
| Returns the maximise button, (or nullptr if there isn't one). More...
Public Member Functions inherited from ResizableWindow
| ResizableWindow (const String &name, bool addToDesktop)
| Creates a ResizableWindow. More...
| ResizableWindow (const String &name, Colour backgroundColour, bool addToDesktop)
| Creates a ResizableWindow. More...
| ~ResizableWindow () override
| Destructor. More...
Colour | getBackgroundColour () const noexcept
| Returns the colour currently being used for the window's background. More...
void | setBackgroundColour (Colour newColour)
| Changes the colour currently being used for the window's background. More...
void | setResizable (bool shouldBeResizable, bool useBottomRightCornerResizer)
| Make the window resizable or fixed. More...
bool | isResizable () const noexcept
| Returns true if resizing is enabled. More...
void | setResizeLimits (int newMinimumWidth, int newMinimumHeight, int newMaximumWidth, int newMaximumHeight) noexcept
| This sets the maximum and minimum sizes for the window. More...
void | setDraggable (bool shouldBeDraggable) noexcept
| Can be used to enable or disable user-dragging of the window. More...
bool | isDraggable () const noexcept
| Returns true if the window can be dragged around by the user. More...
ComponentBoundsConstrainer * | getConstrainer () noexcept
| Returns the bounds constrainer object that this window is using. More...
void | setConstrainer (ComponentBoundsConstrainer *newConstrainer)
| Sets the bounds-constrainer object to use for resizing and dragging this window. More...
void | setBoundsConstrained (const Rectangle< int > &newBounds)
| Calls the window's setBounds method, after first checking these bounds with the current constrainer. More...
bool | isFullScreen () const
| Returns true if the window is currently in full-screen mode. More...
void | setFullScreen (bool shouldBeFullScreen)
| Puts the window into full-screen mode, or restores it to its normal size. More...
bool | isMinimised () const
| Returns true if the window is currently minimised. More...
void | setMinimised (bool shouldMinimise)
| Minimises the window, or restores it to its previous position and size. More...
bool | isKioskMode () const
| Returns true if the window has been placed in kiosk-mode. More...
String | getWindowStateAsString ()
| Returns a string which encodes the window's current size and position. More...
bool | restoreWindowStateFromString (const String &previousState)
| Restores the window to a previously-saved size and position. More...
Component * | getContentComponent () const noexcept
| Returns the current content component. More...
void | setContentOwned (Component *newContentComponent, bool resizeToFitWhenContentChangesSize)
| Changes the current content component. More...
void | setContentNonOwned (Component *newContentComponent, bool resizeToFitWhenContentChangesSize)
| Changes the current content component. More...
void | clearContentComponent ()
| Removes the current content component. More...
void | setContentComponentSize (int width, int height)
| Changes the window so that the content component ends up with the specified size. More...
virtual BorderSize< int > | getBorderThickness ()
| Returns the width of the frame to use around the window. More...
virtual BorderSize< int > | getContentComponentBorder ()
| Returns the insets to use when positioning the content component. More...
void | addToDesktop ()
| Adds the window to the desktop using the default flags. More...
void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr) override
Public Member Functions inherited from TopLevelWindow
| TopLevelWindow (const String &name, bool addToDesktop)
| Creates a TopLevelWindow. More...
| ~TopLevelWindow () override
| Destructor. More...
bool | isActiveWindow () const noexcept
| True if this is currently the TopLevelWindow that is actively being used. More...
void | centreAroundComponent (Component *componentToCentreAround, int width, int height)
| This will set the bounds of the window so that it's centred in front of another window. More...
void | setDropShadowEnabled (bool useShadow)
| Turns the drop-shadow on and off. More...
bool | isDropShadowEnabled () const noexcept
| True if drop-shadowing is enabled. More...
void | setUsingNativeTitleBar (bool useNativeTitleBar)
| Sets whether an OS-native title bar will be used, or a JUCE one. More...
bool | isUsingNativeTitleBar () const noexcept
| Returns true if the window is currently using an OS-native title bar. More...
void | addToDesktop ()
| Adds the window to the desktop using the default flags. More...
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
String | getName () const noexcept
| Returns the name of this component. More...
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container. More...
Component * | findFocusContainer () const
| Returns the focus container for this component. More...
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component. More...
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component. More...
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus. More...
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
String | getTitle () const noexcept
| Returns the title text for this component. More...
void | setTitle (const String &newTitle)
| Sets the title for this component. More...
String | getDescription () const noexcept
| Returns the description for this component. More...
void | setDescription (const String &newDescription)
| Sets the description for this component. More...
String | getHelpText () const noexcept
| Returns the help text for this component. More...
void | setHelpText (const String &newHelpText)
| Sets the help text for this component. More...
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients. More...
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients. More...
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible. More...
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...

## Static Public Member Functions
static void | showDialog (const String &dialogTitle, Component *contentComponent, Component *componentToCentreAround, Colour backgroundColour, bool escapeKeyTriggersCloseButton, bool shouldBeResizable=false, bool useBottomRightCornerResizer=false)
| Easy way of quickly showing a dialog box containing a given component. More...
static int | showModalDialog (const String &dialogTitle, Component *contentComponent, Component *componentToCentreAround, Colour backgroundColour, bool escapeKeyTriggersCloseButton, bool shouldBeResizable=false, bool useBottomRightCornerResizer=false)
| Easy way of quickly showing a dialog box containing a given component. More...
Static Public Member Functions inherited from TopLevelWindow
static int | getNumTopLevelWindows () noexcept
| Returns the number of TopLevelWindow objects currently in use. More...
static TopLevelWindow * | getTopLevelWindow (int index) noexcept
| Returns one of the TopLevelWindow objects currently in use. More...
static TopLevelWindow * | getActiveTopLevelWindow () noexcept
| Returns the currently-active top level window. More...
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...

## Protected Member Functions
void | resized () override
bool | keyPressed (const KeyPress &) override
float | getDesktopScaleFactor () const override
Protected Member Functions inherited from ResizableWindow
void | paint (Graphics &) override
void | moved () override
| (if overriding this, make sure you call ResizableWindow::moved() in your subclass) More...
void | resized () override
| (if overriding this, make sure you call ResizableWindow::resized() in your subclass) More...
void | mouseDown (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
void | mouseUp (const MouseEvent &) override
void | lookAndFeelChanged () override
void | childBoundsChanged (Component *) override
void | parentSizeChanged () override
void | visibilityChanged () override
void | activeWindowStatusChanged () override
int | getDesktopWindowStyleFlags () const override
void | getBorderThickness (int &left, int &top, int &right, int &bottom)
void | getContentComponentBorder (int &left, int &top, int &right, int &bottom)
Protected Member Functions inherited from TopLevelWindow
void | focusOfChildComponentChanged (FocusChangeType) override
void | parentHierarchyChanged () override
void | recreateDesktopWindow ()
void | visibilityChanged () override

## Additional Inherited Members
Public Types inherited from DocumentWindow
enum | TitleBarButtons { minimiseButton = 1 , maximiseButton = 2 , closeButton = 4 , allButtons = 7 }
| The set of available button-types that can be put on the title bar. More...
enum | ColourIds { textColourId = 0x1005701 }
| A set of colour IDs to use to change the colour of various aspects of the window. More...
Public Types inherited from ResizableWindow
enum | ColourIds { backgroundColourId = 0x1005700 }
| A set of colour IDs to use to change the colour of various aspects of the window. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
Protected Attributes inherited from ResizableWindow
std::unique_ptr< ResizableCornerComponent > | resizableCorner
std::unique_ptr< ResizableBorderComponent > | resizableBorder

## Detailed Description

A dialog-box style window.

This class is a convenient way of creating a DocumentWindow with a close button that can be triggered by pressing the escape key.

Any of the methods available to a DocumentWindow or ResizableWindow are also available to this, so it can be made resizable, have a menu bar, etc.

You can either override or use an instance of the DialogWindow class directly, or you can use a DialogWindow::LaunchOptions structure to quickly set up and launch a box containing a content component.

If you use the class directly, you'll need to override the DocumentWindow::closeButtonPressed() method to handle the user clicking the close button - for more info, see the DocumentWindow help.

See also
  DocumentWindow, ResizableWindow

## Constructor & Destructor Documentation

## ◆ DialogWindow()

DialogWindow::DialogWindow | ( | const String & | name,
|  | Colour | backgroundColour,
|  | bool | escapeKeyTriggersCloseButton,
|  | bool | addToDesktop = `true`,
|  | float | desktopScale = `1.0f`
| ) |  |

Creates a DialogWindow.

Parameters

  name | the name to give the component - this is also the title shown at the top of the window. To change this later, use setName()
  backgroundColour | the colour to use for filling the window's background.
  escapeKeyTriggersCloseButton | if true, then pressing the escape key will cause the close button to be triggered
  addToDesktop | if true, the window will be automatically added to the desktop; if false, you can use it as a child component
  desktopScale | specifies the scale to use when drawing the window. In a plugin, the host controls the scale used to render the plugin editor. You should query the editor scale with Component::getApproximateScaleFactorForComponent() and pass the result here. You can ignore this parameter in a standalone app

## ◆ ~DialogWindow()

DialogWindow::~DialogWindow | ( |  | ) |
| override

Destructor.

If a content component has been set with setContentOwned(), it will be deleted.

## Member Function Documentation

## ◆ showDialog()

static void DialogWindow::showDialog | ( | const String & | dialogTitle,
|  | Component * | contentComponent,
|  | Component * | componentToCentreAround,
|  | Colour | backgroundColour,
|  | bool | escapeKeyTriggersCloseButton,
|  | bool | shouldBeResizable = `false`,
|  | bool | useBottomRightCornerResizer = `false`
| ) |  |
| static

Easy way of quickly showing a dialog box containing a given component.

Note: This method has been superseded by the DialogWindow::LaunchOptions structure, which does the same job with some extra flexibility. The showDialog method is here for backwards compatibility, but please use DialogWindow::LaunchOptions in new code.

This will open and display a DialogWindow containing a given component, making it modal, but returning immediately to allow the dialog to finish in its own time. If you want to block and run a modal loop until the dialog is dismissed, use showModalDialog() instead.

To close the dialog programmatically, you should call exitModalState (returnValue) on the DialogWindow that is created. To find a pointer to this window from your contentComponent, you can do something like this:

if (DialogWindow* dw = contentComponent->findParentComponentOfClass<DialogWindow>())
dw->exitModalState (1234);
Component::findParentComponentOfClass
TargetClass * findParentComponentOfClass() const
Searches the parent components for a component of a specified class.
Definition: juce_Component.h:814
DialogWindow
A dialog-box style window.
Definition: juce_DialogWindow.h:53

Parameters

  dialogTitle | the dialog box's title
  contentComponent | the content component for the dialog box. Make sure that this has been set to the size you want it to be before calling this method. The component won't be deleted by this call, so you can re-use it or delete it afterwards
  componentToCentreAround | if this is not a nullptr, it indicates a component that you'd like to show this dialog box in front of. See the DocumentWindow::centreAroundComponent() method for more info on this parameter
  backgroundColour | a colour to use for the dialog box's background colour
  escapeKeyTriggersCloseButton | if true, then pressing the escape key will cause the close button to be triggered
  shouldBeResizable | if true, the dialog window has either a resizable border, or a corner resizer
  useBottomRightCornerResizer | if shouldBeResizable is true, this indicates whether to use a border or corner resizer component. See ResizableWindow::setResizable()

## ◆ showModalDialog()

static int DialogWindow::showModalDialog | ( | const String & | dialogTitle,
|  | Component * | contentComponent,
|  | Component * | componentToCentreAround,
|  | Colour | backgroundColour,
|  | bool | escapeKeyTriggersCloseButton,
|  | bool | shouldBeResizable = `false`,
|  | bool | useBottomRightCornerResizer = `false`
| ) |  |
| static

Easy way of quickly showing a dialog box containing a given component.

Note: This method has been superseded by the DialogWindow::LaunchOptions structure, which does the same job with some extra flexibility. The showDialog method is here for backwards compatibility, but please use DialogWindow::LaunchOptions in new code.

This will open and display a DialogWindow containing a given component, returning when the user clicks its close button.

It returns the value that was returned by the dialog box's runModalLoop() call.

To close the dialog programmatically, you should call exitModalState (returnValue) on the DialogWindow that is created. To find a pointer to this window from your contentComponent, you can do something like this:

if (DialogWindow* dw = contentComponent->findParentComponentOfClass<DialogWindow>())
dw->exitModalState (1234);

Parameters

  dialogTitle | the dialog box's title
  contentComponent | the content component for the dialog box. Make sure that this has been set to the size you want it to be before calling this method. The component won't be deleted by this call, so you can re-use it or delete it afterwards
  componentToCentreAround | if this is not a nullptr, it indicates a component that you'd like to show this dialog box in front of. See the DocumentWindow::centreAroundComponent() method for more info on this parameter
  backgroundColour | a colour to use for the dialog box's background colour
  escapeKeyTriggersCloseButton | if true, then pressing the escape key will cause the close button to be triggered
  shouldBeResizable | if true, the dialog window has either a resizable border, or a corner resizer
  useBottomRightCornerResizer | if shouldBeResizable is true, this indicates whether to use a border or corner resizer component. See ResizableWindow::setResizable()

## ◆ escapeKeyPressed()

virtual bool DialogWindow::escapeKeyPressed | ( |  | ) |
| virtual

Called when the escape key is pressed.

This can be overridden to do things other than the default behaviour, which is to hide the window. Return true if the key has been used, or false if it was ignored.

## ◆ resized()

void DialogWindow::resized | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ keyPressed()

bool DialogWindow::keyPressed | ( | const KeyPress & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ getDesktopScaleFactor()

float DialogWindow::getDesktopScaleFactor | ( |  | ) | const
| overrideprotectedvirtual

Reimplemented from Component.

References Desktop::getGlobalScaleFactor(), and Desktop::getInstance().

The documentation for this class was generated from the following file:

- juce_DialogWindow.h